{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "676d0b96-f24c-4ff0-8984-bb5eabb4386e",
   "metadata": {},
   "source": [
    "# 2.6 Δημιουργία του πρώτου μας προγράμματος Java σε ένα ΟΠΕ\n",
    "© Γιάννης Κωστάρας\n",
    "\n",
    "---\n",
    "\n",
    "[<](../2.5-RecursiveMethods/2.5-RecursiveMethods.ipynb) | [Δ](../../TOC.ipynb) | [>](../2.7-Debugging/2.7-Debugging.ipynb)\n",
    "\n",
    "---\n",
    "\n",
    "### Μαθησιακοί στόχοι\n",
    "Σε αυτήν την ενότητα θα μάθουμε:\n",
    "\n",
    "* πώς να γράψουμε το πρώτο μας εκτελέσιμο πρόγραμμα Java με έναν απλό κειμενογράφο καθώς και με ΟΠΕ\n",
    "* πώς να μεταγλωττίσουμε και να εκτελέσουμε το πρόγραμμά μας\n",
    "* πώς να διαβάζουμε τα ορίσματα γραμμής εντολών που περνά στο πρόγραμμά μας ο χρήστης\n",
    "\n",
    "## Εισαγωγή\n",
    "Μέχρι τώρα γνωρίσαμε τις εντολές της γλώσσας Java μέσα από το JShell. Αλλά τα πραγματικά προγράμματα Java δεν τα τρέχουμε μέσα από το JShell. Μπορούμε να χρησιμοποιήσουμε έναν απλό κειμενογράφο όπως το Notepad, Notepad++, Sublime, TextMate, Vi, Emacs κλπ. ή μπορούμε να χρησιμοποιήσουμε ένα _Ολοκληρωμένο Περιβάλλον Εργασίας_ (_ΟΠΕ_ ή _Integrated Development Environment, IDE_). \n",
    "\n",
    "## Το πρώτο μας εκτελέσιμο πρόγραμμα Java με έναν κειμενογράφο\n",
    "Ανοίξτε τον αγαπημένο σας κειμενογράφο (προσοχή θέλουμε έναν κειμενογράφο που μπορεί να αποθηκεύει απλό κείμενο, π.χ. το Word δεν μας βοηθάει), και γράψτε το παρακάτω πρόγραμμα:\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "5c421a21-e810-412e-8bcc-f4ab80ced6a3",
   "metadata": {},
   "outputs": [],
   "source": [
    "public class HelloWorld {\n",
    "   public static void main(String[] args) {\n",
    "     System.out.println(\"Hello, World!\");\n",
    "   }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6a66cc98-ec6a-4b48-8dbc-a3956d780579",
   "metadata": {},
   "source": [
    "Αναγνωρίζετε ίσως την εντολή ```System.out.println(\"Hello, World!\");```. Τα πάντα στην Java είναι κλάσεις (class). Θα μιλήσουμε για τις κλάσεις στα μαθήματα της επόμενης εβδομάδας. Ορίζουμε μια κλάση με την δεσμευμένη λέξη ```class``` και το όνομα της κλάσης ```HelloWorld```. Για την ονομασία των κλάσεων (αλλά και όλων των ονομάτων που ορίζουμε εμείς στο πρόγραμμα), ακολουθείται, εκ συμβάσεως, ο \"τρόπος καμήλας\" (Camel case), δηλ. όταν ξεκινά μια νέα λέξη αυτή ξεκινά με κεφαλαίο γράμμα. Έτσι, π.χ. το όνομα της κλάσης μας αποτελείται από δυο λέξης _Hello_ και _World_ και ακολουθώντας τον τρόπο καμήλας την ονομάζουμε _HelloWorld_. Σε άλλες γλώσσες προγραμματισμού που χρησιμοποιείται π.χ. ο χαρακτήρας κάτω παύλα (```_```) θα ονομαζόταν ```Hello_world```, αλλά αυτό δε συνιστάται στη Java.\n",
    "\n",
    "Το ```public``` δηλώνει ότι αυτή η κλάση είναι δημόσια, δηλ. προσβάσιμη από οπουδήποτε στο πρόγραμμα αλλά και από την ΕΜ (JVM). Τα προγράμματα Java αποτελούνται από δεκάδες, εκατοντάδες ή και χιλιάδες κλάσεις. \n",
    "\n",
    "Όπως έχουμε ήδη δει, ένα μπλοκ κώδικα περικλείεται μέσα σε άγκιστρα ```{}```, οπότε τα άγκιστρα ορίζουν την αρχή και το τέλος της κλάσης. Μέσα σε μια κλάση ορίζουμε μεθόδους. Η κλάση μας περιέχει μια μόνο μέθοδο με όνομα ```main()```  που έχει ως παράμετρο μια συστοιχία τύπου ```String[]``` με όνομα ```args``` (φυσικά μπορείτε να ονομάσετε την παράμετρο όπως εσείς θέλετε αλλά συνηθίζεται να την ονομάζουμε ```args```) και η οποία δεν επιστρέφει κάποια τιμή (```void```). Η παράμετρος ```args``` περιέχει τα ορίσματα εισόδου της γραμμής εντολών που πληκτρολογεί ο χρήστης όταν καλεί το πρόγραμμα. Έχετε δει π.χ. εντολές του Linux ή του DOS όπως ```cp file1 dir1``` που αντιγράφει το αρχείο ```file1``` στο φάκελο ```dir1```. Τα ```file1``` και ```dir1``` είναι ορίσματα εισόδου της εντολής ```cp```. Αν η εντολή ```cp``` ήταν γραμμένη σε Java, τότε αυτές θα αποθηκεύονταν στην παράμετρο ```args``` και θα ήταν διαθέσιμα στη ```main()```. Θα δούμε ένα παράδειγμα παρακάτω.\n",
    "\n",
    "Η ```main()``` έχει μια ιδιαίτερη σημασία στη Java. Όπως και στη C/C++ και άλλες γλώσσες προγραμματισμού, δηλώνει την αρχή του προγράμματός μας. Κάθε πρόγραμμα Java πρέπει να περιέχει μια μέθοδο ```main()``` μέσα σε μια κλάση η οποία εκτελείται πρώτη από την ΕΜ της Java. Είναι το σημείο εκκίνησης του προγράμματός σας.\n",
    "\n",
    "Πριν την εμφάνιση του jshell στην έκδοση 9 της Java, όλα τα βιβλία Java ξεκινούσαν με το παραπάνω πρόγραμμα καθώς δεν υπήρχε η δυνατότητα να εκτελέσει κανείς προγράμματα Java παρά μόνο μέσα από μια κλάση με μια μέθοδο ```main()```.\n",
    "\n",
    "Αποθηκεύστε το πρόγραμμα σε ένα αρχείο με όνομα ```HelloWorld.java```. Συνίσταται να αποθηκεύουμε το αρχείο με το ίδιο όνομα όπως και η κλάση μας. Στη συνέχεια ανοίξτε μια γραμμή εντολών DOS ή ένα κέλυφος shell και δώστε την εντολή:\n",
    "\n",
    "```bash\n",
    "$ java Helloworld.java\n",
    "Hello, World!\n",
    "``` \n",
    "\n",
    "Από την έκδοση 11 και μετά μπορούμε να εκτελέσουμε ένα πρόγραμμα Java που περιορίζεται σε ένα μόνο αρχείο με την εντολή ```java``` όπως είδαμε παραπάνω. Προσοχή όμως, αυτό ισχύει για ένα μόνο αρχείο ```.java```. Αν το πρόγραμμά σας αποτελείται από πολλά αρχεία ```.java```, η εντολή αυτή δε θα δουλέψει. Μπορείτε όμως να ορίσετε πολλές κλάσεις σ' ένα αρχείο ```.java``` αρκεί η κλάση που περιέχει τη μέθοδο ```main()``` να ορίζεται πρώτη στο αρχείο. Διαβάστε περισσότερα [εδώ](https://www.infoq.com/articles/single-file-execution-java11/). \n",
    "\n",
    "Πριν την έκδοση 11, έπρεπε πρώτα να μεταγλωττίσουμε τον πηγαίο κώδικα παράγοντας το αρχείο ```HelloWorld.class``` και στη συνέχεια να εκτελέσουμε το ```.class``` αρχείο:\n",
    "\n",
    "```bash\n",
    "$ javac Helloworld.java\n",
    "$ ls\n",
    "HelloWorld.class HelloWorld.java\n",
    "$ java HelloWorld\n",
    "Hello, World!\n",
    "```\n",
    "Τροποποιήστε τώρα το πρόγραμμα όπως παρακάτω:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "7505441a-05cd-440b-a117-7da47dab5d91",
   "metadata": {},
   "outputs": [],
   "source": [
    "public class HelloWorld {\n",
    "   public static void main(String[] args) {\n",
    "       if (args.length == 1) {\n",
    "           System.out.println(\"Hello \" + args[0]);\n",
    "       } else {\n",
    "           System.out.println(\"Hello, World!\");\n",
    "       }\n",
    "   }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6cbc3c5a-64cc-4c27-9c51-7dc5ab122e20",
   "metadata": {},
   "source": [
    "και εκτελέστε το ως εξής:\n",
    "\n",
    "```bash\n",
    "$ java Helloworld.java Γιάννης\n",
    "Hello Γιάννης\n",
    "```\n",
    "\n",
    "Μπορούμε επομένως να διαβάσουμε δεδομένα από το χρήστη με δυο τρόπους:\n",
    "\n",
    "1. Περνώντας ορίσματα γραμμής εντολών κατά την εκτέλεση του προγράμματος\n",
    "1. Με την ```Scanner``` όπως είδαμε στα προηγούμενα μαθήματα"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ed34973d-3ca9-42d6-8983-7c2303c429a7",
   "metadata": {},
   "source": [
    "_Άσκηση:_ Τροποποιήστε το παραπάνω πρόγραμμα ώστε να εμφανίζει στην έξοδο τις παραμέτρους γραμμής εντολής που εισήγαγε ο χρήστης σε διαφορετικές γραμμές. Π.χ.:\n",
    "\n",
    "```bash\n",
    "$ java HelloWorld Δευτέρα Τρίτη Τετάρτη\n",
    "Δευτέρα\n",
    "Τρίτη\n",
    "Τετάρτη\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "3f4b67d8-522b-47b8-b152-4bd1b6ce2716",
   "metadata": {},
   "source": [
    "## Το πρώτο μας εκτελέσιμο πρόγραμμα Java με Apache NetBeans\n",
    "\n",
    "Αν και μπορείτε κάλλιστα να αναπτύξετε προγράμματα, να τα μεταγλωττίσετε και να τα εκτελέσετε όπως περιγράψαμε προηγουμένως, δηλ. χρησιμοποιώντας τη γραμμή εντολών, ένα ΟΠΕ σας βοηθάει να αναπτύξετε προγράμματα ευκολότερα και γρηγορότερα.\n",
    "  \n",
    "Ας δούμε πώς μπορούμε να γράψουμε το παραπάνω πρόγραμμα στο NetBeans. Κατ' αρχήν θα πρέπει να δημιουργήσουμε ένα νέο έργο (project). Από το μενού **File -> New Project** επιλέξτε την κατηγορία **Java** και το Project **Java Application**, όπως φαίνεται στην παρακάτω εικόνα, και πατήστε **Next**.\n",
    "\n",
    "![](assets/Fig1.png)\n",
    "\n",
    "**Εικόνα 2.6.1** _Δημιουργία νέου έργου Java στο Apache NetBeans (Βήμα 1)_\n",
    "\n",
    "Δώστε το όνομα _HelloWorld_ για το έργο και επιλέξτε το φάκελο στον οποίο θα αποθηκευθεί (βλ. Εικόνα 2).\n",
    "\n",
    "![](assets/Fig2.png)\n",
    "\n",
    "**Εικόνα 2.6.2** _Δημιουργία νέου έργου Java στο Apache NetBeans (Βήμα 2)_\n",
    "\n",
    "Όπως βλέπετε στην εικόνα 3, έχει δημιουργηθεί μια νέα κλάση ```Main``` η οποία περιλαμβάνει τη στατική μέθοδο ```main()```.\n",
    " \n",
    "![](assets/Fig3.png)\n",
    "\n",
    "**Εικόνα 2.6.3** _Νέο έργο Java στο Apache NetBeans_\n",
    "\n",
    "_Συμβουλή για NetBeans_ Πληκτρολογήστε ```psvm``` και ```Tab``` για να εμφανίσει το NetBeans ```public static void main(String[] args) {}```.\n",
    "\n",
    "Επικολλήστε τον παρακάτω κώδικα μέσα στη μέθοδο ```main()```:\n",
    "\n",
    "```\n",
    "System.out.println(\"Hello, World!\");\n",
    "```\n",
    "\n",
    "_Συμβουλή για NetBeans_ H συντομογραφία ```sout``` και ```Tab``` εκτυπώνει την εντολή ```System.out.println```.\n",
    "\n",
    "Για να μεταγλωττίσετε το αρχείο ```HelloWorld.java``` και να το εκτελέσετε, πατήστε απλά το κουμπί ```Run``` όπως φαίνεται στην παραπάνω εικόνα.\n",
    "\n",
    "Φυσικά μπορείτε να γράψετε όσες εντολές θέλετε μέσα στα άγκιστρα της ```main()``` μεθόδου.\n",
    "\n",
    "Τροποποιήστε το πρόγραμμα όπως παρακάτω:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "id": "766f784f-bb1e-44b4-844a-fd694652e2a1",
   "metadata": {},
   "outputs": [],
   "source": [
    "public class HelloWorld {\n",
    "   public static void main(String[] args) {\n",
    "       if (args.length == 1) {\n",
    "           System.out.println(\"Hello \" + args[0]);\n",
    "       } else {\n",
    "           System.out.println(\"Hello, World!\");\n",
    "       }\n",
    "   }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "489c0b68-f75f-4f56-8df4-c88cc2963793",
   "metadata": {},
   "source": [
    "Για να περάσετε ένα όρισμα γραμμής εντολών στο πρόγραμμα:\n",
    "\n",
    "1. Επιλέξτε την πτυσσόμενη λίστα **default config** από τη γραμμή εργαλείων και επιλέξτε **Customize**\n",
    "1. Στο παράθυρο που εμφανίζεται, εισάγετε το όνομά σας στο πλαίσιο κειμένου με ετικέτα \"Arguments\" (βλ. Εικόνα 2.6.4)\n",
    "1. Πατήστε **ΟΚ** και εκτελέστε πάλι το πρόγραμμα.\n",
    "1. Θα δείτε στο κάτω μέρος (παράθυρο _Output_) την έξοδο: ```Hello Γιάννης```.\n",
    "\n",
    "![](assets/Fig4.png)\n",
    "\n",
    "**Εικόνα 2.6.4** _Πέρασμα ορισμάτων γραμμής εντολών στο NetBeans_"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b7ca8965-2daa-4521-9300-7019de7a268b",
   "metadata": {},
   "source": [
    "## Το πρώτο μας εκτελέσιμο πρόγραμμα Java με MS Visual Studio Code\n",
    "\n",
    "1. Δημιουργήστε ένα νέο φάκελο όπου θα αποθηκεύσετε το έργο σας (project).\n",
    "1. Στο Visual Studio Code (VS Code) βεβαιωθείτε ότι έχετε εγκαταστήσει το \"Extension Pack for Java\" πατώντας στο κουμπί **Extensions** από τη γραμμή εργαλείων στα αριστερά και πληκτρολογώντας ```java``` στο πλαίσιο κειμένου αναζήτησης.\n",
    "1. Από το VS Code ανοίξτε τον φάκελο που δημιουργήσατε στο βήμα 1 από το μενού **File -> Open Folder...**\n",
    "1. Επιλέξτε το μενού **View -> Command Palette** και πληκτρολογήστε ```java```.\n",
    "1. Στη συνέχεια επιλέξτε από το ίδιο μενού **Java: Create Java Project...**\n",
    "1. Από τις εμφανιζόμενες επιλογές, επιλέξτε **No build tools**.\n",
    "1. Πατήστε **Select the project location** για να επιβεβαιώσετε ότι το έργο θα δημιουργηθεί στον φάκελο που έχετε ήδη ανοίξει.\n",
    "1. Δώστε ένα όνομα για το έργο, π.χ. ```HelloWorld```\n",
    "1. Δημιουργήθηκε ένα νέο έργο (βλ. Εικόνα 2.6.4) το οποίο περιέχει την κλάση ```App``` και τη μέθοδο ```main()``` κατά τα γνωστά.\n",
    "1. Για να το εκτελέσετε πατήστε το κουμπί **Run** ή τον υπερσύνδεσμο _Run main_ πάνω από την μέθοδο ```main()```.\n",
    "\n",
    "![](assets/Fig5.png)\n",
    "\n",
    "**Εικόνα 2.6.5** _Νέο έργο Java στο Visual Studio Code_\n",
    "\n",
    "Τροποποιήστε το πρόγραμμα όπως παρακάτω:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "eb34e5a1-55f8-4f14-ba14-6b5c88e23383",
   "metadata": {},
   "outputs": [],
   "source": [
    "public class HelloWorld {\n",
    "   public static void main(String[] args) {\n",
    "       if (args.length == 1) {\n",
    "           System.out.println(\"Hello \" + args[0]);\n",
    "       } else {\n",
    "           System.out.println(\"Hello, World!\");\n",
    "       }\n",
    "   }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "0a06c41f-c6a5-4afd-b073-236f3a12d0f4",
   "metadata": {},
   "source": [
    "Επ' ευκαιρία, ελέγξτε και το Denigma πατώντας στο κουμπί **Explain (Denigma)** στη γραμμή κατάστασης στο κάτω μέρος του VS Code. Να το αποτέλεσμα για το παραπάνω πρόγραμμα:\n",
    "\n",
    "```\n",
    "Code Explanation by Denigma\n",
    "The code is a class that prints \"Hello, World!\"\n",
    "to the console.\n",
    "The main method is called when the program starts up and it has two possible outcomes: if there's only one argument passed in, then it prints \"Hello\" followed by whatever was passed in; otherwise, it prints \"Hello, World!\n",
    "\".\n",
    "The code is used to print \"Hello, World!\"\n",
    "on the console.\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d23beda7-e4a5-4c8e-b45d-fce7a943f060",
   "metadata": {},
   "source": [
    "## Το πρώτο μας εκτελέσιμο πρόγραμμα Java με BlueJ\n",
    "\n",
    "1. Εκκινήστε το BlueJ\n",
    "1. Επιλέξτε το μενού **Project -> New Project**\n",
    "1. Δώστε ένα όνομα για το έργο, ```HelloWorld``` και επιλέξτε την τοποθεσία (Location) που θα αποθηκευθεί και πατήστε **ΟΚ**.\n",
    "1. Πατήστε στο κουμπί **New Class** και ονομάστε τη ```HelloWorld```\n",
    "1. Θα πρέπει να βλέπετε την ίδια εικόνα με τη 2.6.6.\n",
    "1. Κάντε διπλό κλικ πάνω στην κλάση ```HelloWorld``` για να ανοίξει ο κειμενογράφος.\n",
    "\n",
    "![](assets/Fig6.png)\n",
    "\n",
    "**Εικόνα 2.6.6** _Νέο έργο Java στο BlueJ με την κλάση ```HelloWorld```_\n",
    "\n",
    "Επιλέξτε στον κειμενογράφο όλο το πρόγραμμα που δημιούργησε το BlueJ και αντικαταστήστε το με το παρακάτω:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "id": "a0f26739-9c1b-49bf-bdbb-a91d188b7906",
   "metadata": {},
   "outputs": [],
   "source": [
    "public class HelloWorld {\n",
    "   public static void main(String[] args) {\n",
    "       if (args.length == 1) {\n",
    "           System.out.println(\"Hello \" + args[0]);\n",
    "       } else {\n",
    "           System.out.println(\"Hello, World!\");\n",
    "       }\n",
    "   }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "8f9e6934-ac57-40bc-8818-7f4adcf69197",
   "metadata": {},
   "source": [
    "7. Πατήστε το κουμπί **Compile** για να το μεταγλωττίσετε.\n",
    "8. Όταν τελειώσει η μεταγλώττιση, κάντε δεξί κλικ στην κλάση ```HelloWorld``` στο κυρίως παράθυρο και επιλέξτε **void main(String[] ...)** από το μενού που εμφανίζεται.\n",
    "9. Στο παράθυρο που εμφανίζεται, εισάγετε μέσα στα άγκιστρα το όνομά σας μέσα σε εισαγωγικά, π.χ. ```{\"Γιάννης\"}```.\n",
    "\n",
    "Θα ανοίξει ένα άλλο παράθυρο το οποίο θα εμφανίσει:\n",
    "\n",
    "```\n",
    "Hello Γιάννης\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "45490456-9e62-41f9-958a-598a50116395",
   "metadata": {},
   "source": [
    "**Σημείωση** _Μπορείτε να αλλάξετε τη γλώσσα διεπαφής του BlueJ από το μενού **Preferences** και καρτέλα **Interface**_. "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "4fbc685f-d41a-4d38-9b11-54024003dd18",
   "metadata": {},
   "source": [
    "## Περίληψη\n",
    "\n",
    "Σε αυτό το μάθημα δημιουργήσαμε την πρώτη μας εκτελέσιμη κλάση Java:\n",
    "\n",
    "1. σε έναν απλό κειμενογράφο\n",
    "1. στο Apache NetBeans\n",
    "1. στο Microsoft Visual Studio\n",
    "1. στο BlueJ\n",
    "\n",
    "και μάθαμε πώς να την εκτελούμε. Επίσης μάθαμε πώς να διαβάζουμε ορίσματα που περνάμε στη γραμμή εντολών κατά την εκτέλεση του προγράμματός μας.\n",
    "\n",
    "Αφού πλέον μάθατε πώς να εκτελείτε προγράμματα Java με τον παραδοσιακό τρόπο, θα μπορούσατε να κάνετε μια επανάληψη των όσων μάθαμε δημιουργώντας εκτελέσιμα προγράμματα χρησιμοποιώντας ένα από τα παραπάνω ΟΠΕ."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "5514e1ea-576f-43e9-a26f-028cae9c85b5",
   "metadata": {},
   "source": [
    "## Πηγές\n",
    "1. Barnes D.J. & Kolling M. (2012), _Objects First with Java™ A Practical Introduction Using BlueJ_, 5th Edition, Pearson.\n",
    "1. Caure B., [How to Use Visual Studio Code with Java?](https://www.baeldung.com/java-visual-studio-code).  \n",
    "1. [Εκπαιδευτικό εγχειρίδιο Java με το NetBeans](https://drive.google.com/file/d/0B3xd-fm6gEqac1RZZVlWTVpNWEk/view).\n",
    "1. Κασάπογλου Μ., [Εισαγωγή στην Java με VS Code](https://kassapoglou.github.io/java/java-programming.html)\n",
    "1. Kolling M. (μετάφραση Ζερβός Τ.) (), [Το εγχειρίδιο του BlueJ](https://bluej.org/tutorial/tutorial-greek.pdf), έκδοση 1.4, University of Southern Denmark."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "f49d037b-f783-42be-a784-58e8d005378a",
   "metadata": {},
   "source": [
    "---\n",
    "\n",
    "[<](../2.5-RecursiveMethods/2.5-RecursiveMethods.ipynb) | [Δ](../../TOC.ipynb) | [>](../2.7-Debugging/2.7-Debugging.ipynb)\n",
    "\n",
    "---"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Java",
   "language": "java",
   "name": "java"
  },
  "language_info": {
   "codemirror_mode": "java",
   "file_extension": ".jshell",
   "mimetype": "text/x-java-source",
   "name": "Java",
   "pygments_lexer": "java",
   "version": "17+35-LTS-2724"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
